*************
* Observer4 *
*************

CSubject=CREATEOBJECT('ISubject')
CObserver1=CREATEOBJECT('IObserver','Observateur1')
CObserver2=CREATEOBJECT('IObserver','Observateur2')
CObserver3=CREATEOBJECT('IObserver','Observateur3')

_SCREEN.CLS
_SCREEN.FONTSIZE=20

CSubject.Attach(CObserver1)
CSubject.Attach(CObserver2)
CSubject.Attach(CObserver3)
CSubject.SetState('Etat un')

CSubject.Detach(CObserver2)
CSubject.SetState('Etat deux')

CSubject.Attach(CObserver2)
CSubject.SetState('Etat trois')

CSubject.Detach(CObserver1)
CSubject.Detach(CObserver2)
CSubject.Detach(CObserver3)
CSubject.SetState("Je suis seul dans l'univers")

_SCREEN.FONTSIZE=10

CLEAR ALL

DEFINE CLASS IObserver AS CUSTOM

	cObserverState=''

	PROCEDURE INIT(tcName)
		THIS.NAME=tcName
	ENDPROC

	PROCEDURE Update(toSubject)
		THIS.cObserverState=toSubject.GetState()
			? "Update "+THIS.NAME+' '+toSubject.NAME+' '+THIS.cObserverState			
	ENDPROC

ENDDEFINE

DEFINE CLASS ISubject AS CUSTOM

	oObservers=NULL
	cSubjectState=''

	PROCEDURE INIT()
		THIS.oObservers=CREATEOBJECT('collection')
	ENDPROC

	PROCEDURE Attach(oObserver)
		THIS.oObservers.ADD(oObserver,oObserver.NAME)
	ENDPROC

	PROCEDURE Detach(oObserver)
		THIS.oObservers.REMOVE(oObserver.NAME)
	ENDPROC

	PROCEDURE Notify()
		? '------------------'
		? "Notify "+THIS.NAME+' '+THIS.cSubjectState
		?
		FOR EACH loObj AS IObserver IN THIS.oObservers
			loObj.Update(THIS)
		ENDFOR
		? '------------------' 
	ENDPROC

	PROCEDURE GetState()
		RETURN THIS.cSubjectState
	ENDPROC

	PROCEDURE SetState(tcState)
		THIS.cSubjectState=tcState
		THIS.Notify()
	ENDPROC

ENDDEFINE
